package com.example.smartwatch;

import android.content.Context;
import android.content.SharedPreferences;

/**
 * Created by Asier on 14/03/2015.
 */
public class InformacionDeConexion {



    // Instance
    private static InformacionDeConexion mInstance = null;

    private Context mContext;

    // Target device's MAC address
    private String mDeviceAddress = null;
    // Name of the connected device
    private String mDeviceName = null;


    private InformacionDeConexion (Context c) {
        mContext = c;

        SharedPreferences prefs = mContext.getSharedPreferences(Constantes.PREFERENCE_NAME, Context.MODE_PRIVATE);
        mDeviceAddress = prefs.getString(Constantes.PREFERENCE_CONN_INFO_ADDRESS, null);
        mDeviceName = prefs.getString(Constantes.PREFERENCE_CONN_INFO_NAME, null);
    }

    public synchronized static InformacionDeConexion getInstance(Context c) {
        if(mInstance == null) {
            if(c != null)
                mInstance = new InformacionDeConexion(c);
            else
                return null;
        }
        return mInstance;
    }

    public void resetearInformacionDeConexion() {
        mDeviceAddress = null;
        mDeviceName = null;
    }

    public String CogerNombreDispositibo() {
        return mDeviceName;
    }

    public void PonerNombreDispositibo(String name) {
        mDeviceName = name;

        // At this time, connection is established successfully.
        // Save connection info in shared preference.
        SharedPreferences prefs = mContext.getSharedPreferences(Constantes.PREFERENCE_NAME, Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        editor.putString(Constantes.PREFERENCE_CONN_INFO_ADDRESS, mDeviceAddress);
        editor.putString(Constantes.PREFERENCE_CONN_INFO_NAME, mDeviceName);
        editor.apply();
    }

    public String CogerDireccionDelDispositibo() {
        return mDeviceAddress;
    }

    public void PonerDireccionDispositibo(String address) {
        mDeviceAddress = address;
    }

}
