package com.example.smartwatch;


import android.content.Intent;
import android.service.notification.NotificationListenerService;
import android.service.notification.StatusBarNotification;
import android.util.Log;
import android.os.Bundle;


/**
 * Created by Asier on 26/04/2015.
 */
public class NotificationService extends NotificationListenerService {

    private static final String TAG = "NotificationService";

    // Notification broadcast intent key
    public static final String NOTIFICATION_KEY_CMD = "notification_command";
    public static final String NOTIFICATION_KEY_ID = "notification_id";
    public static final String NOTIFICATION_KEY_PACKAGE = "notification_package";
    public static final String NOTIFICATION_KEY_TICKER = "notification_ticker";
    public static final String NOTIFICATION_KEY_TITLE = "notification_title";
    public static final String NOTIFICATION_KEY_TEXT = "notification_text";
    public static final String NOTIFICATION_KEY_BIG_TEXT = "notification_big_text";
    public static final String NOTIFICATION_KEY_SUB_TEXT = "notification_sub_text";
    public static final String NOTIFICATION_KEY_SUM_TEXT = "notification_sum_text";
    public static final String NOTIFICATION_KEY_TEXT_LINES = "notification_text_lines";




    // Notification command type
    public static final int NOTIFICATION_CMD_ADD = 1;
    public static final int NOTIFICATION_CMD_REMOVE = 2;
    public static final int NOTIFICATION_CMD_LIST = 3;




    @Override
    public void onCreate() {
        super.onCreate();

    }

    @Override
    public void onDestroy() {
        super.onDestroy();

    }

    @Override
    public void onNotificationPosted(StatusBarNotification sbn) {
        Log.d(TAG,"**********  onNotificationPosted");
        Log.d(TAG, "ID :" + sbn.getId() + "t" + sbn.getNotification().tickerText + "t" + sbn.getPackageName());

        String ticker = sbn.getNotification().tickerText.toString();
        Bundle extras = sbn.getNotification().extras;
        String title = extras.getString("android.title");
        String text = extras.getCharSequence("android.text").toString();
        //String bigtext = extras.getCharSequence("android.bigText").toString();
        //String subtext=extras.getCharSequence("android.subText").toString();
        //String sumtext=extras.getCharSequence("android.summaryText").toString();
        //String textlines=extras.getCharSequence("android.textLines").toString();

        Intent i = new  Intent(Constantes.NOTIFICATION_LISTENER);
        i.putExtra(NOTIFICATION_KEY_CMD, NOTIFICATION_CMD_ADD);
        i.putExtra(NOTIFICATION_KEY_ID, sbn.getId());
        i.putExtra(NOTIFICATION_KEY_PACKAGE, sbn.getPackageName());
        i.putExtra(NOTIFICATION_KEY_TICKER, ticker);
        i.putExtra(NOTIFICATION_KEY_TITLE, title);
        i.putExtra(NOTIFICATION_KEY_TEXT, text);
       // i.putExtra(NOTIFICATION_KEY_BIG_TEXT,bigtext );
       // i.putExtra(NOTIFICATION_KEY_SUB_TEXT, subtext);
       // i.putExtra(NOTIFICATION_KEY_SUM_TEXT, sumtext);
       // i.putExtra(NOTIFICATION_KEY_TEXT_LINES, textlines);
        sendBroadcast(i);

    }

    @Override
    public void onNotificationRemoved(StatusBarNotification sbn) {
        Log.d(TAG,"********** onNOtificationRemoved");
        Log.d(TAG,"ID :" + sbn.getId() + "t" + sbn.getNotification().tickerText +"t" + sbn.getPackageName());

       /* Intent i = new  Intent(Constantes.NOTIFICATION_LISTENER);
        i.putExtra(NOTIFICATION_KEY_CMD, NOTIFICATION_CMD_ADD);
        i.putExtra(NOTIFICATION_KEY_ID, sbn.getId());
        i.putExtra(NOTIFICATION_KEY_PACKAGE, sbn.getPackageName());
        i.putExtra(NOTIFICATION_KEY_TICKER, ticker);
        i.putExtra(NOTIFICATION_KEY_TITLE, title);
        i.putExtra(NOTIFICATION_KEY_TEXT, text);
        sendBroadcast(i);*/
    }



}
