package com.example.smartwatch;


import android.os.Handler;
import java.util.Calendar;
import android.util.Log;

/**
 * Created by Asier on 15/03/2015.
 */
public class ProtocoloEnvioDatos {

    private static final String TAG = "Protocolo Envio Datos";

    private ConexionBluetooth mBTManager = null;
    private Handler mHandler = null;





    public ProtocoloEnvioDatos(ConexionBluetooth cb, Handler errorHandler) {
        mBTManager = cb;
        mHandler = errorHandler;
        // Poner un Broadcast receiver para recoger el estado de la bateria

    }

    public Transaccion CrearProtocolo() {
        return new Transaccion();
    }

    public class Transaccion {

        public static final int MAX_MESSAGE_LENGTH = 10000;

        // Command types
        public static final int COMMAND_TYPE_NONE = 0x00;

        public static final int COMMAND_TYPE_SET_TIME = 0x02;
        public static final int COMMAND_TYPE_SET_BATTERY = 0x03;
        public static final int COMMAND_TYPE_SET_TELEPHONY_CALL= 0x04;
       // public static final int COMMAND_TYPE_SET_NOTIFICATION_MESSAGE = 0x05;
        public static final int COMMAND_TYPE_SET_WHATSAPP_NOTIFICATION = 0x05;
        public static final int COMMAND_TYPE_SET_GMAIL_NOTIFICATION = 0x06;
        public static final int COMMAND_TYPE_SET_FACEBOOK_NOTIFICATION = 0x07;
        public static final int COMMAND_TYPE_SET_CALL_NOTIFICATION = 0x08;
        public static final int COMMAND_TYPE_SET_SMS_NOTIFICATION = 0x09;







        // byte definitions for buffer setting
        private static final byte TRANSACTION_START_BYTE = (byte)0xfc;
        private static final byte TRANSACTION_END_BYTE = (byte)0xfd;


        // Transaction instance status
        private static final int STATE_NONE = 0;		// Instance created
        private static final int STATE_BEGIN = 1;		// Initialize transaction
        private static final int STATE_SETTING_FINISHED = 2;	// End of setting parameters
        private static final int STATE_TRANSFERED = 3;	// End of sending transaction data
        private static final int STATE_ERROR = -1;		// Error occurred

        // Transaction parameters
        private int mState = STATE_NONE;

        private byte[] mBuffer = null;

        private int mCommandType = COMMAND_TYPE_NONE;
        private int mId=0x00;
        private byte mDateMonth = 0x00;
        private byte mDateDay = 0x00;
        private byte mDateWeek = 0x00;
        private byte mDateNoon = 0x00;
        private byte mDateHour = 0x00;
        private byte mDateMinute = 0x00;
        public byte MiNivelBateria=0x00;
        public byte MiEscalaBateria=0x00;
        public byte MiMetodoCargaBateria=0x00;
        public byte MiEstadoCargaBateria=0x00;
       // private String mNotification = null;
        private String WhatsappNotification=null;
        private String WhatsappNotificationInfo=null;
        private String FacebookNotification=null;
        private String FacebookNotificationInfo=null;
        private String GmailNotification=null;
        private String GmailNotificationInfo=null;
        private String CallNotification=null;
        private String SMSNotification=null;
        private String SMSNotificationInfo=null;
        private String mPackage=null;
        private String TelephoneNumber=null;
        private String dospuntos=":";
        byte[]TwoPoint=dospuntos.getBytes();
        //private byte Ringing=0x00;
        //private byte Dialing=0x01;


        public void begin() {
            mState = STATE_BEGIN;

            mCommandType = COMMAND_TYPE_NONE;


            //Fecha y Hora
            mDateMonth = 0x00;
            mDateDay = 0x00;
            mDateWeek = 0x00;
            mDateNoon = 0x00;
            mDateHour = 0x00;
            mDateMinute = 0x00;

            // Mensaje de Notificaciones

            //mNotification = null;
            WhatsappNotification=null;
            FacebookNotification=null;
            GmailNotification=null;
            CallNotification=null;
            SMSNotification=null;
            WhatsappNotificationInfo=null;
            FacebookNotificationInfo=null;
            GmailNotificationInfo=null;
            SMSNotificationInfo=null;

            //Bateria
            MiNivelBateria=0x00;
            MiEscalaBateria=0x00;
            MiMetodoCargaBateria=0x00;
            MiEstadoCargaBateria=0x00;

            // Numero de telefono
            TelephoneNumber=null;
            //Ringing=0x00;
            //Dialing=0x01;

            mBuffer = null;
        }

        public void setCommand(int cmd) {
            switch(cmd) {


                case COMMAND_TYPE_SET_TIME:
                case COMMAND_TYPE_SET_BATTERY:
                case COMMAND_TYPE_SET_TELEPHONY_CALL:
                //case COMMAND_TYPE_SET_NOTIFICATION_MESSAGE:
                case COMMAND_TYPE_SET_WHATSAPP_NOTIFICATION:
                case COMMAND_TYPE_SET_GMAIL_NOTIFICATION:
                case COMMAND_TYPE_SET_FACEBOOK_NOTIFICATION:
                case COMMAND_TYPE_SET_CALL_NOTIFICATION:
                case COMMAND_TYPE_SET_SMS_NOTIFICATION:
                    mCommandType = cmd;
                    break;
                default:
                    mCommandType = COMMAND_TYPE_NONE;
                    break;
            }
        }

        public void setDate(int month, int day, int week, int noon, int hour, int minute) {
            mDateMonth = (byte)month;
            mDateDay = (byte)day;
            mDateWeek = (byte)week;
            mDateNoon = (byte)noon;
            mDateHour = (byte)hour;
            mDateMinute = (byte)minute;
        }

        public void setDate() {
            Calendar c = Calendar.getInstance();
            int month = c.get(Calendar.MONTH);
            int day = c.get(Calendar.DAY_OF_MONTH);
            int week = c.get(Calendar.DAY_OF_WEEK);
            int noon = c.get(Calendar.AM_PM);
            int hour = c.get(Calendar.HOUR_OF_DAY);
           // int hour = c.get(Calendar.HOUR);
            int minute = c.get(Calendar.MINUTE);

            mDateMonth = (byte)month;
            mDateDay = (byte)day;
            mDateWeek = (byte)week;
            mDateNoon = (byte)noon;
            mDateHour = (byte)hour;
            mDateMinute = (byte)minute;
        }
        public void setBattery (int mnb,int meb, int mmcb, int mecb){

            MiNivelBateria= (byte)mnb;
            MiEscalaBateria= (byte) meb;
            MiMetodoCargaBateria=(byte) mmcb;
            MiEstadoCargaBateria=(byte) mecb;
        }

        public void setTelephoneNumber (String number){
            TelephoneNumber= number;
        }

        //public void callState (byte ring, byte speak){
           // Ringing= ring;
           // Dialing= speak;
       // }

        public void setId(int id) {
            mId = id;
        }

        /**
         * Set Notification message to send
         * @param id	Identifier - WARNING: use lower 1 byte only
         * @param mensaje	String to send
         */
        public void setNotificationMessage(int id, String mensaje ) {
            mId = id;
            //mNotification = mensaje;

        }

        public void setWhatsappNotification (String W, String X){
            WhatsappNotification=W;
            WhatsappNotificationInfo=X;

        }
        public void setFacebookNotification (String F, String H ){
            FacebookNotification=F;
            FacebookNotificationInfo=H;

        }
        public void setGmailNotification (String G, String E){
            GmailNotification=G;
            GmailNotificationInfo=E;

        }
        public void setCallNotification (String C){
            CallNotification=C;

        }
        public void setSMSNotification (String A){
            SMSNotification=A;
           // SMSNotificationInfo=B;

        }



        public void settingFinished() {
            mState = STATE_SETTING_FINISHED;

            switch(mCommandType) {


                // Command byte + Date bytes
                case COMMAND_TYPE_SET_TIME:
                    // Make buffer
                    // [Transaction start signal : 1byte : 0xfd]
                    // [command type : 1byte]
                    // [data packet : month(1byte), day(1byte), week(1byte), noon(1byte), hour(1byte), min(1byte) ]
                    // [Transaction end signal : 1byte : 0xfe]
                    mBuffer = new byte[9];

                    mBuffer[0] = TRANSACTION_START_BYTE;	// Transaction start signal
                    mBuffer[1] = (byte)mCommandType;	// Command
                    mBuffer[2] = mDateMonth;
                    mBuffer[3] = mDateDay;
                    mBuffer[4] = mDateWeek;
                    mBuffer[5] = mDateNoon;
                    mBuffer[6] = mDateHour;
                    mBuffer[7] = mDateMinute;
                    mBuffer[8] = TRANSACTION_END_BYTE;

                    break;
                case COMMAND_TYPE_SET_BATTERY:
                    mBuffer = new byte[7];

                    mBuffer[0] = TRANSACTION_START_BYTE;	// Transaction start signal
                    mBuffer[1] = (byte)mCommandType;	// Command
                    mBuffer[2] = MiNivelBateria ;
                    mBuffer[3] = MiEscalaBateria;
                    mBuffer[4] = MiEstadoCargaBateria;
                    mBuffer[5] = MiMetodoCargaBateria;
                    mBuffer[6] = TRANSACTION_END_BYTE;

                    break;

                /*
                case COMMAND_TYPE_SET_NOTIFICATION_MESSAGE:
                    if (mNotification==null||mNotification.length()<1){
                    mState=STATE_ERROR;
                        break;
                    }

                   byte[]notificationBuffer=mNotification.getBytes();
                    // Make buffer
                    // [Transaction start signal : 1byte : 0xfd]
                    // [command type : 1byte]
                    // [Notification ID : 1byte]
                    // [data packet : various size: Currently max 1000 byte ]
                    // [Transaction end signal : 1byte : 0xfe]
                    mBuffer=new byte[3+notificationBuffer.length];
                    mBuffer[0] = TRANSACTION_START_BYTE;	// Transaction start signal
                    mBuffer[1] = (byte)mCommandType;		// Command
                   // mBuffer[2] = (byte)mId;// Message ID

                    System.arraycopy(notificationBuffer, 0, mBuffer, 2,
                            (notificationBuffer.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : notificationBuffer.length);

                    mBuffer[mBuffer.length-1] = TRANSACTION_END_BYTE;


                    break;
                    */

                case COMMAND_TYPE_SET_WHATSAPP_NOTIFICATION:
                    if (WhatsappNotification==null||WhatsappNotification.length()<1){
                        mState=STATE_ERROR;
                        break;
                    }

                    byte[] WhatsappBuffer=WhatsappNotification.getBytes();
                    byte[] WhatsappTextBuffer=WhatsappNotificationInfo.getBytes();
                    // Make buffer
                    // [Transaction start signal : 1byte : 0xfd]
                    // [command type : 1byte]
                    // [data packet : various size: Currently max 1000 byte ]
                    // [Transaction end signal : 1byte : 0xfe]
                    mBuffer=new byte[3+WhatsappBuffer.length+WhatsappTextBuffer.length+TwoPoint.length];
                    mBuffer[0] = TRANSACTION_START_BYTE;	// Transaction start signal
                    mBuffer[1] = (byte)mCommandType;		// Command
                    // mBuffer[2] = (byte)mId;// Message ID

                    System.arraycopy(WhatsappBuffer, 0, mBuffer, 2,
                            (WhatsappBuffer.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : WhatsappBuffer.length);

                    System.arraycopy(TwoPoint, 0, mBuffer,WhatsappBuffer.length+2 ,
                            (TwoPoint.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : TwoPoint.length);

                    System.arraycopy(WhatsappTextBuffer,0 , mBuffer,WhatsappBuffer.length+TwoPoint.length+2,
                            (WhatsappTextBuffer.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : WhatsappTextBuffer.length);


                    mBuffer[mBuffer.length-1] = TRANSACTION_END_BYTE;

                    break;
                case COMMAND_TYPE_SET_GMAIL_NOTIFICATION:
                    if (GmailNotification==null||GmailNotification.length()<1){
                        mState=STATE_ERROR;
                        break;
                    }

                    byte[] GmailBuffer=GmailNotification.getBytes();
                    byte[] GmailTextBuffer=GmailNotificationInfo.getBytes();
                    // Make buffer
                    // [Transaction start signal : 1byte : 0xfd]
                    // [command type : 1byte]
                    // [data packet : various size: Currently max 1000 byte ]
                    // [Transaction end signal : 1byte : 0xfe]
                    mBuffer=new byte[3+GmailBuffer.length+TwoPoint.length+GmailTextBuffer.length];
                    mBuffer[0] = TRANSACTION_START_BYTE;	// Transaction start signal
                    mBuffer[1] = (byte)mCommandType;		// Command
                    // mBuffer[2] = (byte)mId;// Message ID

                    System.arraycopy(GmailBuffer, 0, mBuffer, 2,
                            (GmailBuffer.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : GmailBuffer.length);

                    System.arraycopy(TwoPoint, 0, mBuffer,GmailBuffer.length+2 ,
                            (TwoPoint.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : TwoPoint.length);

                    System.arraycopy(GmailTextBuffer,0 , mBuffer,GmailBuffer.length+TwoPoint.length+2,
                            (GmailTextBuffer.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : GmailTextBuffer.length);

                    mBuffer[mBuffer.length-1] = TRANSACTION_END_BYTE;

                    break;

                case COMMAND_TYPE_SET_FACEBOOK_NOTIFICATION:
                    if (FacebookNotification==null||FacebookNotification.length()<1){
                        mState=STATE_ERROR;
                        break;
                    }

                    byte[] FacebookBuffer=FacebookNotification.getBytes();
                    byte[] FacebookTextBuffer=FacebookNotificationInfo.getBytes();
                    // Make buffer
                    // [Transaction start signal : 1byte : 0xfd]
                    // [command type : 1byte]
                    // [data packet : various size: Currently max 1000 byte ]
                    // [Transaction end signal : 1byte : 0xfe]
                    mBuffer=new byte[3+FacebookBuffer.length+TwoPoint.length+FacebookTextBuffer.length];
                    mBuffer[0] = TRANSACTION_START_BYTE;	// Transaction start signal
                    mBuffer[1] = (byte)mCommandType;		// Command
                    // mBuffer[2] = (byte)mId;// Message ID

                    System.arraycopy(FacebookBuffer, 0, mBuffer, 2,
                            (FacebookBuffer.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : FacebookBuffer.length);

                    System.arraycopy(TwoPoint, 0, mBuffer,FacebookBuffer.length+2 ,
                            (TwoPoint.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : TwoPoint.length);

                    System.arraycopy(FacebookTextBuffer,0 , mBuffer,FacebookBuffer.length+TwoPoint.length+2,
                            (FacebookTextBuffer.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : FacebookTextBuffer.length);

                    mBuffer[mBuffer.length-1] = TRANSACTION_END_BYTE;

                    break;

                case COMMAND_TYPE_SET_CALL_NOTIFICATION:
                    if (CallNotification==null||CallNotification.length()<1){
                        mState=STATE_ERROR;
                        break;
                    }

                    byte[] CallBuffer=CallNotification.getBytes();
                    // Make buffer
                    // [Transaction start signal : 1byte : 0xfd]
                    // [command type : 1byte]
                    // [data packet : various size: Currently max 1000 byte ]
                    // [Transaction end signal : 1byte : 0xfe]
                    mBuffer=new byte[3+CallBuffer.length];
                    mBuffer[0] = TRANSACTION_START_BYTE;	// Transaction start signal
                    mBuffer[1] = (byte)mCommandType;		// Command
                    // mBuffer[2] = (byte)mId;// Message ID

                    System.arraycopy(CallBuffer, 0, mBuffer, 2,
                            (CallBuffer.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : CallBuffer.length);

                    mBuffer[mBuffer.length-1] = TRANSACTION_END_BYTE;

                    break;
                case COMMAND_TYPE_SET_SMS_NOTIFICATION:
                    if (SMSNotification==null||SMSNotification.length()<1){
                        mState=STATE_ERROR;
                        break;
                    }

                    byte[] SMSBuffer=SMSNotification.getBytes();
                        //byte[] SMSTextBuffer=SMSNotificationInfo.getBytes();
                    // Make buffer
                    // [Transaction start signal : 1byte : 0xfd]
                    // [command type : 1byte]
                    // [data packet : various size: Currently max 1000 byte ]
                    // [Transaction end signal : 1byte : 0xfe]
                    mBuffer=new byte[3+SMSBuffer.length];
                    mBuffer[0] = TRANSACTION_START_BYTE;	// Transaction start signal
                    mBuffer[1] = (byte)mCommandType;		// Command
                    // mBuffer[2] = (byte)mId;// Message ID

                    System.arraycopy(SMSBuffer, 0, mBuffer, 2,
                            (SMSBuffer.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : SMSBuffer.length);

                   /* System.arraycopy(TwoPoint, 0, mBuffer,SMSBuffer.length+2 ,
                            (TwoPoint.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : TwoPoint.length);

                    System.arraycopy(SMSTextBuffer,0 , mBuffer,SMSBuffer.length+TwoPoint.length+2,
                            (SMSTextBuffer.length > MAX_MESSAGE_LENGTH) ? MAX_MESSAGE_LENGTH : SMSTextBuffer.length);*/

                    mBuffer[mBuffer.length-1] = TRANSACTION_END_BYTE;


                    break;
                case COMMAND_TYPE_SET_TELEPHONY_CALL:
                    if (TelephoneNumber==null||TelephoneNumber.length()<1){
                        mState=STATE_ERROR;
                        break;
                    }

                    byte[]TelephoneBuffer=TelephoneNumber.getBytes();
                    // Make buffer
                    // [Transaction start signal : 1byte : 0xfd]
                    // [command type : 1byte]
                    // [telephone number: size 9 ]
                    // [Transaction end signal : 1byte : 0xfe]
                    mBuffer=new byte[3+TelephoneBuffer.length];
                    mBuffer[0] = TRANSACTION_START_BYTE;	// Transaction start signal
                    mBuffer[1] = (byte)mCommandType;       // Command
                    //mBuffer[2] = (byte)Ringing;           // =1 phone ringing ( someone calling)
                    //mBuffer[3] = (byte)Dialing;          //=1 call taken
                    System.arraycopy(TelephoneBuffer, 0, mBuffer, 2,TelephoneBuffer.length);
                    mBuffer[mBuffer.length-1] = TRANSACTION_END_BYTE;
                    break;

                default:
                    mState = STATE_ERROR;
                    break;
            }
        }

        public byte[] getPacket() {
            if(mState == STATE_SETTING_FINISHED) {
                return mBuffer;
            }
            return null;
        }



        public boolean sendTransaction() {
            if(mBuffer == null) {
                Log.e(TAG, "##### Ooooooops!! No sending buffer!! Check command!!");
                return false;
            }

            // For debug
            if(mBuffer.length > 0) {
                StringBuilder sb = new StringBuilder();

                switch(mBuffer[1]) {


                    case COMMAND_TYPE_SET_TIME:
                        sb.append("COMMAND_TYPE_SET_TIME : ");
                        break;
                    case COMMAND_TYPE_SET_BATTERY:
                        sb.append("COMMAND_TYPE_SET_BATTERY : ");
                        break;
                   /* case COMMAND_TYPE_SET_NOTIFICATION_MESSAGE:
                        sb.append("COMMAND_TYPE_SET_NOTIFICATION_MESSAGE : ");
                         break;*/
                    case COMMAND_TYPE_SET_TELEPHONY_CALL:
                        sb.append("COMMAND_TYPE_SET_TELEPHONY_CALL : ");
                        break;
                    default:
                        break;
                }

                for(int i=0; i<mBuffer.length; i++) {
                    sb.append(String.format("%02X, ", mBuffer[i]));
                }


                Log.d(TAG, sb.toString());
            }

            if(mState == STATE_SETTING_FINISHED) {
                if(mBTManager != null) {
                    // Check that we're actually connected before trying anything
                    if (mBTManager.CogerEstado() == ConexionBluetooth.STATE_CONNECTED) {
                        // Check that there's actually something to send
                        if (mBuffer.length > 0) {
                            // Get the message bytes and tell the BluetoothChatService to write
                            mBTManager.write(mBuffer);

                            mState = STATE_TRANSFERED;
                            return true;
                        }
                        mState = STATE_ERROR;
                    }
                    mHandler.obtainMessage(Constantes.MESSAGE_CMD_ERROR_NOT_CONNECTED).sendToTarget();
                }
            }
            return false;
        }
    }	// End of class Transaccion
// Battery BroadcastReceiver


}


