package com.example.smartwatch;

import android.app.Activity;
import android.app.AlertDialog;
import android.bluetooth.BluetoothAdapter;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.graphics.Color;
import android.os.BatteryManager;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.support.v7.app.ActionBarActivity;
import android.os.Bundle;
import android.text.Html;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.ImageView;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.util.Log;
import android.widget.Toast;




public class SmartWatchActivity extends ActionBarActivity {

    // Debugging
    private static final String TAG = "SmartWatchActivity";



    // Context, System
    private Context mContext;
    private SmartWatchService mService;

    private ActivityHandler mActivityHandler;

    // Notification broadcast receiver
    private NotificationInfo MiRecibidor;



    // Global
    private boolean mStopService = false;

    private ImageView mImageBT = null;
    private TextView mTextStatus = null;
    TextView txtInfoCargaBateria;
    TextView EscBat;
    TextView TipodeCarga;
    TextView Cargando;
    TableLayout tab;




    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        //----- System, Context
        mContext = this;//.getApplicationContext();
        mActivityHandler = new ActivityHandler();


        setContentView(R.layout.activity_smart_watch);
        tab=(TableLayout)findViewById(R.id.tab);


        MiRecibidor = new NotificationInfo();
        IntentFilter filter = new IntentFilter();
        filter.addAction("Notificaciones");
        registerReceiver(MiRecibidor,filter);


        // Setup views
        mImageBT = (ImageView) findViewById(R.id.status_title);
        mImageBT.setImageDrawable(getResources().getDrawable(android.R.drawable.presence_invisible));
        mTextStatus = (TextView) findViewById(R.id.status_text);
        mTextStatus.setText(getResources().getString(R.string.bt_state_init));





        // Do data initialization after service started and binded
        doStartService();
    }

    @Override
    public synchronized void onStart() {
        super.onStart();


    }

    @Override
    public synchronized void onPause() {
        super.onPause();
    }

    @Override
    public void onStop() {

        super.onStop();
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        finalizeActivity();
    }

    @Override
    public void onLowMemory (){
        super.onLowMemory();
        // onDestroy is not always called when applications are finished by Android system.
        finalizeActivity();
    }
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_smart_watch, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        switch (item.getItemId()) {
            case (R.id.accion_escanear):
                doScan();
                return true;
            //noinspection SimplifiableIfStatement
            case (R.id.battery_info):
               mService.MandarBateria();
                return true;
            case (R.id.hora_fecha):
                mService.MandarHorayFecha();

                return true;

           /* case (R.id.action_send_notifications):
                mService.MandarNotificaciones();
                return true;
            */

            case R.id.quit:
                AlertDialog.Builder dialog = new AlertDialog.Builder(this);

                dialog.setMessage("¿Quieres salir de la aplicacion?");
                dialog.setCancelable(false);
                dialog.setPositiveButton("Si", new DialogInterface.OnClickListener() {

                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        SmartWatchActivity.this.finish();
                        mService.finalizeService();
                    }
                });
                dialog.setNegativeButton("No", new DialogInterface.OnClickListener() {

                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        dialog.cancel();
                    }
                });
                dialog.show();

                return true;


        }
        return super.onOptionsItemSelected(item);
    }



/*****************************************************
 *
 *	Private classes
 *
 ******************************************************/

    /**
     * Service connection
     */
    private ServiceConnection mServiceConn = new ServiceConnection() {

        public void onServiceConnected(ComponentName className, IBinder binder) {
            Log.d(TAG, "Activity - Service connected");

            mService = ((SmartWatchService.SmartWatchServiceBinder) binder).getService();

            // Activity couldn't work with mService until connections are made
            // So initialize parameters and settings here, not while running onCreate()
            initialize();
        }

        public void onServiceDisconnected(ComponentName className) {
            mService = null;
        }
    };

    private void doStartService() {
        Log.d(TAG, "# Activity - doStartService()");
        startService(new Intent(this, SmartWatchService.class));
        bindService(new Intent(this, SmartWatchService.class), mServiceConn, Context.BIND_AUTO_CREATE);
    }

    private void doStopService() {
        Log.d(TAG, "# Activity - doStopService()");
        mService.finalizeService();
        stopService(new Intent(this, SmartWatchService.class));
    }

    /**
     * Initialization / Finalization
     */
    private void initialize() {
        Log.d(TAG, "# Activity - initialize()");
        mService.setupService(mActivityHandler);

        // If BT is not on, request that it be enabled.
        // RetroWatchService.setupBT() will then be called during onActivityResult
        if(!mService.isBluetoothEnabled()) {
            Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
            startActivityForResult(enableIntent, Constantes.REQUEST_ENABLE_BT);
        }




    }

    private void finalizeActivity() {
        Log.d(TAG, "# Activity - finalizeActivity()");

        if(mStopService)
            doStopService();

        unbindService(mServiceConn);


        System.gc();
    }

    /**
     * Launch the DeviceListActivity to see devices and do scan
     */
    private void doScan() {
        Intent intent = new Intent(this, ListaDeDispositibos.class);
        startActivityForResult(intent, Constantes.REQUEST_CONNECT_DEVICE);
    }

    /**
     * Launch notification settings screen
     */
    private void setNotificationAccess() {
        Intent intent=new Intent("android.settings.ACTION_NOTIFICATION_LISTENER_SETTINGS");
        startActivity(intent);
    }

    /**
     * Ensure this device is discoverable by others
     */
    private void ensureDiscoverable() {
        if (mService.getBluetoothScanMode() != BluetoothAdapter.SCAN_MODE_CONNECTABLE_DISCOVERABLE) {
            Intent intent = new Intent(BluetoothAdapter.ACTION_REQUEST_DISCOVERABLE);
            intent.putExtra(BluetoothAdapter.EXTRA_DISCOVERABLE_DURATION, 300);
            startActivity(intent);
        }
    }

/*****************************************************
 *
 *	Public classes
 *
 ******************************************************/

    /**
     * Receives result from external activity
     */
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        Log.d(TAG, "onActivityResult " + resultCode);

        switch(requestCode) {
            case Constantes.REQUEST_CONNECT_DEVICE:
                // When DeviceListActivity returns with a device to connect
                if (resultCode == Activity.RESULT_OK) {
                    // Get the device MAC address
                    String address = data.getExtras().getString(ListaDeDispositibos.EXTRA_DEVICE_ADDRESS);
                    // Attempt to connect to the device
                    if(address != null && mService != null)
                        mService.connectDevice(address);
                }
                break;

            case Constantes.REQUEST_ENABLE_BT:
                // When the request to enable Bluetooth returns
                if (resultCode == Activity.RESULT_OK) {
                    // Bluetooth is now enabled, so set up a BT session
                    mService.setupBT();
                } else {
                    // User did not enable Bluetooth or an error occured
                    Log.e(TAG, "BT is not enabled");
                    Toast.makeText(this, R.string.bt_not_enabled_leaving, Toast.LENGTH_SHORT).show();
                }
                break;
        }	// End of switch(requestCode)
    }





    /*****************************************************
     *
     *	Handler, Callback, Sub-classes
     *
     ******************************************************/

    public class ActivityHandler extends Handler {
        @Override
        public void handleMessage(Message msg)
        {
            switch(msg.what) {
                // BT state message
                case Constantes.MESSAGE_BT_STATE_INITIALIZED:
                    mTextStatus.setText(getResources().getString(R.string.bt_title) + ": " +
                            getResources().getString(R.string.bt_state_init));
                    mImageBT.setImageDrawable(getResources().getDrawable(android.R.drawable.presence_invisible));
                    break;
                case Constantes.MESSAGE_BT_STATE_LISTENING:
                    mTextStatus.setText(getResources().getString(R.string.bt_title) + ": " +
                            getResources().getString(R.string.bt_state_wait));
                    mImageBT.setImageDrawable(getResources().getDrawable(android.R.drawable.presence_invisible));
                    break;
                case Constantes.MESSAGE_BT_STATE_CONNECTING:
                    mTextStatus.setText(getResources().getString(R.string.bt_title) + ": " +
                            getResources().getString(R.string.bt_state_connect));
                    mImageBT.setImageDrawable(getResources().getDrawable(android.R.drawable.presence_away));
                    break;
                case Constantes.MESSAGE_BT_STATE_CONNECTED:
                    if(mService != null) {
                        String deviceName = mService.getDeviceName();
                        if(deviceName != null) {
                            mTextStatus.setText(getResources().getString(R.string.bt_title) + ": " +
                                    getResources().getString(R.string.bt_state_connected) + " " + deviceName);
                            mImageBT.setImageDrawable(getResources().getDrawable(android.R.drawable.presence_online));
                        }
                    }
                    break;
                case Constantes.MESSAGE_BT_STATE_ERROR:
                    mTextStatus.setText(getResources().getString(R.string.bt_state_error));
                    mImageBT.setImageDrawable(getResources().getDrawable(android.R.drawable.presence_busy));
                    break;

                // BT Command status
                case Constantes.MESSAGE_CMD_ERROR_NOT_CONNECTED:
                    mTextStatus.setText(getResources().getString(R.string.bt_cmd_sending_error));
                    mImageBT.setImageDrawable(getResources().getDrawable(android.R.drawable.presence_busy));
                    break;

                ////////////////////////////////////////////
                // Contents changed
                ////////////////////////////////////////////

                case Constantes.MESSAGE_ADD_NOTIFICATION:
                {


                    break;
                }

                case Constantes.MESSAGE_DELETE_NOTIFICATION:
                {

                    break;
                }
                default:
                    break;
            }

            super.handleMessage(msg);
        }
    }	// End of class ActivityHandler

    class NotificationInfo extends BroadcastReceiver{

        @Override
        public void onReceive(Context context, Intent intent) {

            int id = intent.getIntExtra(NotificationService.NOTIFICATION_KEY_ID, -1);
            String packageName = intent.getStringExtra("paquete");
            String textTicker = intent.getStringExtra("notificacion");
            String title = intent.getStringExtra("titulo");
            String text = intent.getStringExtra("texto");
            //String bigtext=intent.getStringExtra("textogrande");
            //String subtext=intent.getStringExtra("subtexto");
            //String sumtext=intent.getStringExtra("resumentexto");
            //String textlines=intent.getStringExtra("lineastexto");

            switch (packageName){
                case (Constantes.WHATSAPP_PACKAGE):
                    mService.MandarNotificacionWhatsapp();
                    break;
                case (Constantes.GMAIL_PACKAGE):
                    mService.MandarNotificacionGmail();

                    break;
                case (Constantes.FACEBOOK_PACKAGE):
                    mService.MandarNotificacionFacebook();
                    break;
                case (Constantes.SMS_PACKAGE):
                    mService.MandarNotificacionSMS();
                    break;
            }


            TableRow tr = new TableRow(getApplicationContext());
            tr.setLayoutParams(new TableRow.LayoutParams( TableRow.LayoutParams.MATCH_PARENT, TableRow.LayoutParams.WRAP_CONTENT));
            TextView textview = new TextView(getApplicationContext());
            textview.setLayoutParams(new TableRow.LayoutParams(TableRow.LayoutParams.WRAP_CONTENT, TableRow.LayoutParams.WRAP_CONTENT,1.0f));
            textview.setTextSize(20);
            textview.setTextColor(Color.parseColor("#0B0719"));
            textview.setText(Html.fromHtml(packageName + "<br><b>" + textTicker + "<br><b>" + title +":" +" <b>" + text));
            tr.addView(textview);
            tab.addView(tr);

        }	// End of onReceive()

    }	// End of class NotificationReceive

}
