package com.example.smartwatch;


import android.app.Service;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.res.Configuration;
import android.os.BatteryManager;
import android.os.Binder;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.widget.Toast;
import android.util.Log;

import java.util.Timer;


/**
 * Created by Asier on 14/03/2015.
 */
public class SmartWatchService extends Service {


    private static final String TAG = "SmartWatchService";


    // Context, System
    private Context mContext = null;
    private static Handler mActivityHandler = null;
    private ServiceHandler mServiceHandler = new ServiceHandler();
    private final IBinder mBinder = new SmartWatchServiceBinder();

    // Notification broadcast receiver
    private NotificationReceiver mReceiver;

    // Bluetooth
    private BluetoothAdapter mBluetoothAdapter = null;
    private ConexionBluetooth mBtManager = null;

    private InformacionDeConexion mConnectionInfo = null;
    private ProtocoloEnvioDatos mProtocolo = null;

    // Bateria
    public int BChargingState = 0;
    public int BChargingMethod = 0;
    public int NivelBateria = 0;
    public int EscalaBateria = 0;

    // Notificaciones

    public int id = 0;
    public String notificacion = null;
    public String paquete = null;
    public String titulo = null;
    public String texto = null;
    public String textogrande = null;
    public String subtexto = null;
    public String resumentexto = null;
    public String lineastexto = null;



    public String Whatsapp;
    public String Whatsapptext;
    public String Facebook;
    public String Facebooktext;
    public String Call;
    public String SMS;
    public String SMStext;
    public String Gmail;
    public String Gmailtext;


    // Estado del telefono

    public int sonando=0;
    public int llamadaCogida=0;
    public String numeroDeTelefono=null;



    /**
     * **************************************************
     * <p/>
     * Overrided methods
     * <p/>
     * ****************************************************
     */
    @Override
    public void onCreate() {
        Log.d(TAG, "# Service - onCreate() starts here");


        mContext = getApplicationContext();
        initialize();
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        Log.d(TAG, "# Service - onStartCommand() starts here");

        // If service returns START_STICKY, android restarts service automatically after forced close.
        // At this time, onStartCommand() method in service must handle null intent.
        return Service.START_STICKY;
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        // This prevents reload after configuration changes
        super.onConfigurationChanged(newConfig);
    }

    @Override
    public IBinder onBind(Intent intent) {
        Log.d(TAG, "# Service - onBind()");
        return mBinder;
    }

    @Override
    public boolean onUnbind(Intent intent) {
        Log.d(TAG, "# Service - onUnbind()");
        return true;
    }

    @Override
    public void onDestroy() {
        Log.d(TAG, "# Service - onDestroy()");
        finalizeService();
    }

    @Override
    public void onLowMemory() {
        Log.d(TAG, "# Service - onLowMemory()");
        // onDestroy is not always called when applications are finished by Android system.
        finalizeService();
    }


    /**
     * **************************************************
     * <p/>
     * Private methods
     * <p/>
     * ****************************************************
     */
    private void initialize() {
        Log.d(TAG, "# Service : initialize ---");


        mConnectionInfo = InformacionDeConexion.getInstance(mContext);


        IntentFilter iFilter = new IntentFilter();
        iFilter.addAction(Intent.ACTION_BATTERY_CHANGED);
        registerReceiver(mBatteryInfoReceiver, iFilter);

        // Set notification broadcast receiver
        mReceiver = new NotificationReceiver();
        IntentFilter filter = new IntentFilter();
        filter.addAction(Constantes.NOTIFICATION_LISTENER);
        registerReceiver(mReceiver, filter);

        // Set telephony listener
        TelephonyStateListener telephonyListener = new TelephonyStateListener();
        TelephonyManager TM = (TelephonyManager) mContext.getSystemService(Context.TELEPHONY_SERVICE);
        TM.listen(telephonyListener, PhoneStateListener.LISTEN_CALL_STATE);

        // Get local Bluetooth adapter
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();

        // If the adapter is null, then Bluetooth is not supported
        if (mBluetoothAdapter == null) {
            Toast.makeText(this, "Bluetooth is not available", Toast.LENGTH_LONG).show();
            return;
        }

        if (!mBluetoothAdapter.isEnabled()) {
            // BT is not on, need to turn on manually.
            // Activity will do this.
        } else {
            if (mBtManager == null) {
                setupBT();
            }
        }


    }

    public void MandarHorayFecha() {
        ProtocoloEnvioDatos.Transaccion Protocolo = mProtocolo.CrearProtocolo();
        Protocolo.begin();
        Protocolo.setCommand(ProtocoloEnvioDatos.Transaccion.COMMAND_TYPE_SET_TIME);
        Protocolo.setDate();
        Protocolo.settingFinished();
        Protocolo.sendTransaction();

    }

    public void MandarBateria() {
        ProtocoloEnvioDatos.Transaccion Protocolo = mProtocolo.CrearProtocolo();
        Protocolo.begin();
        Protocolo.setCommand(ProtocoloEnvioDatos.Transaccion.COMMAND_TYPE_SET_BATTERY);
        Protocolo.setBattery(NivelBateria, EscalaBateria, BChargingMethod, BChargingState);
        Protocolo.settingFinished();
        Protocolo.sendTransaction();

    }
/*
    public void MandarNotificaciones() {
        ProtocoloEnvioDatos.Transaccion Protocolo = mProtocolo.CrearProtocolo();
        Protocolo.begin();
        Protocolo.setCommand(ProtocoloEnvioDatos.Transaccion.COMMAND_TYPE_SET_NOTIFICATION_MESSAGE);
        Protocolo.setNotificationMessage(id, notificacion);
        Protocolo.settingFinished();
        Protocolo.sendTransaction();

    }
*/
public void MandarNotificacionWhatsapp() {
    ProtocoloEnvioDatos.Transaccion Protocolo = mProtocolo.CrearProtocolo();
    Protocolo.begin();
    Protocolo.setCommand(ProtocoloEnvioDatos.Transaccion.COMMAND_TYPE_SET_WHATSAPP_NOTIFICATION);
    Protocolo.setWhatsappNotification(Whatsapp,Whatsapptext);
    Protocolo.settingFinished();
    Protocolo.sendTransaction();
}
    public void MandarNotificacionGmail() {
        ProtocoloEnvioDatos.Transaccion Protocolo = mProtocolo.CrearProtocolo();
        Protocolo.begin();
        Protocolo.setCommand(ProtocoloEnvioDatos.Transaccion.COMMAND_TYPE_SET_GMAIL_NOTIFICATION);
        Protocolo.setGmailNotification(Gmail,Gmailtext);
        Protocolo.settingFinished();
        Protocolo.sendTransaction();
    }

    public void MandarNotificacionLlamada() {
        ProtocoloEnvioDatos.Transaccion Protocolo = mProtocolo.CrearProtocolo();
        Protocolo.begin();
        Protocolo.setCommand(ProtocoloEnvioDatos.Transaccion.COMMAND_TYPE_SET_CALL_NOTIFICATION);
        Protocolo.setCallNotification(Call);
        Protocolo.settingFinished();
        Protocolo.sendTransaction();
    }

    public void MandarNotificacionFacebook() {
        ProtocoloEnvioDatos.Transaccion Protocolo = mProtocolo.CrearProtocolo();
        Protocolo.begin();
        Protocolo.setCommand(ProtocoloEnvioDatos.Transaccion.COMMAND_TYPE_SET_FACEBOOK_NOTIFICATION);
        Protocolo.setFacebookNotification(Facebook,Facebooktext);
        Protocolo.settingFinished();
        Protocolo.sendTransaction();
    }
    public void MandarNotificacionSMS() {
        ProtocoloEnvioDatos.Transaccion Protocolo = mProtocolo.CrearProtocolo();
        Protocolo.begin();
        Protocolo.setCommand(ProtocoloEnvioDatos.Transaccion.COMMAND_TYPE_SET_SMS_NOTIFICATION);
        Protocolo.setSMSNotification(SMS);
        Protocolo.settingFinished();
        Protocolo.sendTransaction();
    }
    public void MandarNotificaciones(){
        MandarNotificacionWhatsapp();
        MandarNotificacionGmail();
        MandarNotificacionFacebook();
        MandarNotificacionLlamada();
    }
    public void MandarEstadoDelTelefono() {
        ProtocoloEnvioDatos.Transaccion Protocolo = mProtocolo.CrearProtocolo();
        Protocolo.begin();
        Protocolo.setCommand(ProtocoloEnvioDatos.Transaccion.COMMAND_TYPE_SET_TELEPHONY_CALL);
        Protocolo.setTelephoneNumber(numeroDeTelefono);
        //Protocolo.callState(sonando,llamadaCogida);
        Protocolo.settingFinished();
        Protocolo.sendTransaction();

    }

    /**
     * **************************************************
     * <p/>
     * Public methods
     * <p/>
     * ****************************************************
     */
    public void finalizeService() {
        Log.d(TAG, "# Service : finalize ---");

        mBluetoothAdapter = null;
        // Stop the bluetooth session
        if (mBtManager != null)
            mBtManager.stop();
        mBtManager = null;

        // Unregister broadcast receiver

        if (mBatteryInfoReceiver != null)
            unregisterReceiver(mBatteryInfoReceiver);
        mBatteryInfoReceiver = null;

        if(mReceiver != null)
            unregisterReceiver(mReceiver);
        mReceiver = null;


    }

    public void setupService(Handler h) {
        mActivityHandler = h;


        if (mBtManager == null)
            setupBT();

        // Inicializar Protocolo
        if (mProtocolo == null)
            mProtocolo = new ProtocoloEnvioDatos(mBtManager, mActivityHandler);


        // If ConnectionInfo holds previous connection info,
        // try to connect using it.
        if (mConnectionInfo.CogerDireccionDelDispositibo() != null && mConnectionInfo.CogerNombreDispositibo() != null) {
            connectDevice(mConnectionInfo.CogerDireccionDelDispositibo());
        }
        // or wait in listening mode
        else {
            if (mBtManager.CogerEstado() == ConexionBluetooth.STATE_NONE) {
                // Start the bluetooth services
                mBtManager.start();
            }
        }
    }

    /**
     * Setup and initialize BT manager
     */
    public void setupBT() {
        Log.d(TAG, "Service - setupBT()");

        // Initialize the BluetoothManager to perform bluetooth connections
        if (mBtManager == null)
            mBtManager = new ConexionBluetooth(this, mServiceHandler);
    }

    /**
     * Check bluetooth is enabled or not.
     */
    public boolean isBluetoothEnabled() {
        if (mBluetoothAdapter == null) {
            Log.e(TAG, "# Service - cannot find bluetooth adapter. Restart app.");
            return false;
        }
        return mBluetoothAdapter.isEnabled();
    }

    /**
     * Get scan mode
     */
    public int getBluetoothScanMode() {
        int scanMode = -1;
        if (mBluetoothAdapter != null)
            scanMode = mBluetoothAdapter.getScanMode();

        return scanMode;
    }

    /**
     * Initiate a connection to a remote device.
     */
    public void connectDevice(String address) {
        Log.d(TAG, "Service - connect to " + address);

        // Get the BluetoothDevice object
        if (mBluetoothAdapter != null) {
            BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);

            if (device != null && mBtManager != null) {
                mBtManager.connect(device);
            }
        }
    }

    /**
     * Connect to a remote device.
     */
    public void connectDevice(BluetoothDevice device) {
        if (device != null && mBtManager != null) {
            mBtManager.connect(device);
        }
    }

    /**
     * Get connected device name
     */
    public String getDeviceName() {
        return mConnectionInfo.CogerNombreDispositibo();
    }

    /**
     * **************************************************
     * <p/>
     * Handler, Listener, Timer, Sub classes
     * <p/>
     * ****************************************************
     */
    public class SmartWatchServiceBinder extends Binder {
        public SmartWatchService getService() {
            return SmartWatchService.this;
        }
    }

    class ServiceHandler extends Handler {
        @Override
        public void handleMessage(Message msg) {

            switch (msg.what) {
                case ConexionBluetooth.MESSAGE_STATE_CHANGE:
                    // Bluetooth state Changed
                    Log.d(TAG, "Service - MESSAGE_STATE_CHANGE: " + msg.arg1);

                    switch (msg.arg1) {
                        case ConexionBluetooth.STATE_NONE:
                            mActivityHandler.obtainMessage(Constantes.MESSAGE_BT_STATE_INITIALIZED).sendToTarget();

                            break;

                        case ConexionBluetooth.STATE_LISTEN:
                            mActivityHandler.obtainMessage(Constantes.MESSAGE_BT_STATE_LISTENING).sendToTarget();
                            break;

                        case ConexionBluetooth.STATE_CONNECTING:
                            mActivityHandler.obtainMessage(Constantes.MESSAGE_BT_STATE_CONNECTING).sendToTarget();
                            break;

                        case ConexionBluetooth.STATE_CONNECTED:
                            mActivityHandler.obtainMessage(Constantes.MESSAGE_BT_STATE_CONNECTED).sendToTarget();


                            break;
                    }
                    break;

                case ConexionBluetooth.MESSAGE_WRITE:
                    Log.d(TAG, "Service - MESSAGE_WRITE: ");
                    break;

                case ConexionBluetooth.MESSAGE_READ:
                    Log.d(TAG, "Service - MESSAGE_READ: ");

                    byte[] readBuf = (byte[]) msg.obj;
                    // construct commands from the valid bytes in the buffer

                    break;

                case ConexionBluetooth.MESSAGE_DEVICE_NAME:
                    Log.d(TAG, "Service - MESSAGE_DEVICE_NAME: ");

                    // save connected device's name and notify using toast
                    String deviceAddress = msg.getData().getString(Constantes.SERVICE_HANDLER_MSG_KEY_DEVICE_ADDRESS);
                    String deviceName = msg.getData().getString(Constantes.SERVICE_HANDLER_MSG_KEY_DEVICE_NAME);

                    if (deviceName != null && deviceAddress != null) {
                        // Remember device's address and name
                        mConnectionInfo.PonerDireccionDispositibo(deviceAddress);
                        mConnectionInfo.PonerNombreDispositibo(deviceName);

                        Toast.makeText(getApplicationContext(),
                                "Connected to " + deviceName, Toast.LENGTH_SHORT).show();
                    }
                    break;

                case ConexionBluetooth.MESSAGE_TOAST:
                    Log.d(TAG, "Service - MESSAGE_TOAST: ");

//				Toast.makeText(getApplicationContext(),
//						msg.getData().getString(Constants.SERVICE_HANDLER_MSG_KEY_TOAST),
//						Toast.LENGTH_SHORT).show();
                    break;

            }    // End of switch(msg.what)

            super.handleMessage(msg);
        }
    }    // End of class MainHandler

    private BroadcastReceiver mBatteryInfoReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();
            if (Intent.ACTION_BATTERY_CHANGED.equals(action)) {
                // Are we charging / charged?
                int status = intent.getIntExtra(BatteryManager.EXTRA_STATUS, -1);
                boolean isCharging = status == BatteryManager.BATTERY_STATUS_CHARGING ||
                        status == BatteryManager.BATTERY_STATUS_FULL;

                // How are we charging?
                int chargePlug = intent.getIntExtra(BatteryManager.EXTRA_PLUGGED, -1);
                boolean usbCharge = chargePlug == BatteryManager.BATTERY_PLUGGED_USB;
                boolean acCharge = chargePlug == BatteryManager.BATTERY_PLUGGED_AC;


                if (isCharging) {
                    BChargingState = 1;
                }//Esta Cargando
                else {
                    BChargingState = 0;
                } //  Esta Descargando

                if (usbCharge) {
                    BChargingMethod = 2;
                }//Cargando en USB
                else if (acCharge) {
                    BChargingMethod = 1;
                }// Cargando con la corriente
                else {
                    BChargingMethod = 0;
                }// Esta descargandose


            }
            int level = intent.getIntExtra(BatteryManager.EXTRA_LEVEL, -1);
            int scale = intent.getIntExtra(BatteryManager.EXTRA_SCALE, -1);
            NivelBateria = level;
            EscalaBateria = scale;

        }

    };

    /**
     * Broadcast receiver class. Receives notification data
     */
    class NotificationReceiver extends BroadcastReceiver {

        @Override
        public void onReceive(Context context, Intent intent) {
            int cmd = intent.getIntExtra(NotificationService.NOTIFICATION_KEY_CMD, 0);
            int noti_id = intent.getIntExtra(NotificationService.NOTIFICATION_KEY_ID, -1);
            String packageName = intent.getStringExtra(NotificationService.NOTIFICATION_KEY_PACKAGE);
            String textTicker = intent.getStringExtra(NotificationService.NOTIFICATION_KEY_TICKER);
            String title=intent.getStringExtra(NotificationService.NOTIFICATION_KEY_TITLE);
            String text=intent.getStringExtra(NotificationService.NOTIFICATION_KEY_TEXT);
           // String bigtext=intent.getStringExtra(NotificationService.NOTIFICATION_KEY_BIG_TEXT);
           // String subtext=intent.getStringExtra(NotificationService.NOTIFICATION_KEY_SUB_TEXT);
           // String sumtext=intent.getStringExtra(NotificationService.NOTIFICATION_KEY_SUM_TEXT);
           // String textlines=intent.getStringExtra(NotificationService.NOTIFICATION_KEY_TEXT_LINES);
            switch (cmd) {

                case NotificationService.NOTIFICATION_CMD_ADD:
                    if (packageName != null) {
                        Log.d(TAG, "** Service - Add noti=" + noti_id + ", package=" + packageName);
                             switch (packageName){
                                 case (Constantes.WHATSAPP_PACKAGE):
                                      Whatsapp=title;
                                      Whatsapptext=text;

                                     break;
                                 case (Constantes.GMAIL_PACKAGE):
                                     Gmail=title;
                                     Gmailtext=text;

                                     break;
                                 case Constantes.FACEBOOK_PACKAGE:
                                     Facebook=title;
                                     Facebooktext=text;
                                     break;
                                 /*case Constantes.FACEBOOK_CHAT_PACKAGE:
                                     Facebook=textTicker;
                                     break;*/
                                 case Constantes.SMS_PACKAGE:
                                     SMS=textTicker;
                                     //SMStext=text;
                                     break;
                             }



                        id = noti_id;
                        notificacion = textTicker;
                        paquete = packageName;
                        titulo=title;
                        texto=text;
                        //textogrande=bigtext;
                        //subtexto=subtext;
                        //resumentexto=sumtext;
                       // lineastexto=textlines;

                        Intent i = new Intent("Notificaciones");
                        i.putExtra("id", id);
                        i.putExtra("paquete", paquete);
                        i.putExtra("notificacion", notificacion);
                        i.putExtra("titulo", titulo);
                        i.putExtra("texto", texto);
                       // i.putExtra("textogrande", textogrande);
                       // i.putExtra("subtexto", subtexto);
                       // i.putExtra("resumentexto", resumentexto);
                       // i.putExtra("lineastexto", lineastexto);
                        sendBroadcast(i);

                        // notify to activity
                        mActivityHandler.obtainMessage(Constantes.MESSAGE_ADD_NOTIFICATION, noti_id, 0).sendToTarget();

                    }

                    break;

                case NotificationService.NOTIFICATION_CMD_REMOVE:
                    Log.d(TAG, "** Service - Delete noti=" + noti_id + ", package=" + packageName);

                    id = 0;
                    notificacion = null;
                    paquete = null;
                    titulo=null;
                    texto=null;
                   // textogrande=null;
                   // subtexto=null;
                   // resumentexto=null;
                   // lineastexto=null;

                    Intent i = new Intent("Notificaciones");
                    i.putExtra("id", id);
                    i.putExtra("paquete", paquete);
                    i.putExtra("notificacion", notificacion);
                    i.putExtra("titulo", titulo);
                    i.putExtra("texto", texto);
                    //i.putExtra("textogrande", textogrande);
                   // i.putExtra("subtexto", subtexto);
                   // i.putExtra("resumentexto", resumentexto);
                   // i.putExtra("lineastexto", lineastexto);
                    sendBroadcast(i);
                    // notify to activity
                    mActivityHandler.obtainMessage(Constantes.MESSAGE_DELETE_NOTIFICATION, noti_id, 0).sendToTarget();


                    break;
            }    // End of switch(cmd)
        }    // End of onReceive()

    }    // End of class NotificationReceive


    public class TelephonyStateListener extends PhoneStateListener {
        @Override
        public void onCallStateChanged(int state, String incomingNumber) {
            Log.d(TAG, "PhoneStateListener - onCallStateChanged();");
            switch (state) {
                case TelephonyManager.CALL_STATE_IDLE:
                    //sonando=0;
                    //llamadaCogida=0;
                   // Toast.makeText(SmartWatchService.this, "SIN LLAMADAS", Toast.LENGTH_SHORT).show();
                    break;

                case TelephonyManager.CALL_STATE_RINGING:
                    //sonando=1;
                   // llamadaCogida=0;
                    numeroDeTelefono=incomingNumber;
                   // Toast.makeText(SmartWatchService.this, "LLAMANDO", Toast.LENGTH_LONG).show();


                    // send to device

                    MandarEstadoDelTelefono();

                    break;
                case TelephonyManager.CALL_STATE_OFFHOOK:
                    //sonando=0;
                    //llamadaCogida=1;
                    numeroDeTelefono=incomingNumber;
                    //Toast.makeText(SmartWatchService.this, "HABLANDO", Toast.LENGTH_LONG).show();

                    MandarEstadoDelTelefono();

                    break;

                default:
                    Log.d(TAG, "PhoneStateListener - Default state=" + state + ", Number=" + incomingNumber);
                    break;
            }
        }


    }
}