  #include <SoftwareSerial.h>
  #include <SPI.h>
  #include <Wire.h>
  #include <Adafruit_GFX.h>
  #include <Adafruit_SSD1306.h>
  #include <math.h>
  #include "bitmap.h"
  
  
  //----- Protocolo De Recogida de datos por Bluetooth
  #define TR_MODO_ESPERA 1
  #define TR_MODO_ESPERA_COMANDO 11
  #define TR_MODO_ESPERA_MENSAJE 101
  #define TR_MODO_ESPERA_TIEMPO 111
  #define TR_MODO_ESPERA_BATERIA 131
  #define TR_MODO_ESPERA_WHATSAPP 141
  #define TR_MODO_ESPERA_GMAIL 142
  #define TR_MODO_ESPERA_FACEBOOK 143
  #define TR_MODO_ESPERA_N_LLAMADA 144
  #define TR_MODO_ESPERA_SMS 145
  #define TR_MODO_ESPERA_LLAMADA 151
  
  #define TR_MODO_ESPERA_COMPLETADO 201
  
  #define TRANSACCION_BYTE_COMIENZO 0xfc
  #define TRANSACCION_BYTE_FINAL 0xfd
  
  #define NINGUN_COMANDO 0x00
  #define COMANDO_PONER_TIEMPO 0x02
  #define COMANDO_PONER_BATERIA 0x03
  #define COMANDO_PONER_LLAMADA 0x04
  #define COMANDO_PONER_WHATSAPP 0x05
  #define COMANDO_PONER_GMAIL 0x06
  #define COMANDO_PONER_FACEBOOK 0x07
  #define COMANDO_PONER_N_LLAMADA 0x08
  #define COMANDO_PONER_SMS 0x09
  
  byte INDICE_TRANSACCION = TR_MODO_ESPERA;
  byte COMANDO_TRANSACCION = NINGUN_COMANDO;
  
  SoftwareSerial BTSerial(6, 7); //(RX, TX)
  
  //////////////////////////////////////////
  /////// FECHA y HORA ////////////////////
  ////////////////////////////////////////
  #define INTERVALO_TIEMPO_ACTUALIZACION 60000
  byte miMes= 1;
  byte miDia = 1;
  byte miSemana = 1;    // 1: SUN, MON, TUE, WED, THU, FRI,SAT
  byte miAmPm = 0;    // 0:AM, 1:PM
  byte miHora = 0;
  byte miMinutos = 0;
  byte miSegundos= 0;
  
  
  #define BUFFER_TIEMPO_MAX 6
  char indiceTiempo = 0;
  char BufferTiempo[6] = {-1, -1, -1, -1, -1, -1};
  
  PGM_P const  StringSemana[] PROGMEM = {"", "Dom", "Lun", "Mar", "Mie", "Jue", "Vie", "Sab"};
  
  unsigned long tiempoAnteriorReloj=0;
   
  //////////////////////////////////////////
  /////// BATERIA /////////////////////////
  ////////////////////////////////////////
  
  byte miNivelBateria=0;
  byte miEscalaBateria=0;
  byte miEstadoCargaBateria;
  byte miMetodoCargaBateria;
  
  #define BUFFER_BATERIA_MAX 4
  char indiceBateria = 0;
  char BufferBateria[4] = {-1, -1, -1, -1};
  
  //////////////////////////////////////////
  /////// NOTIFICACION ////////////////////
  ////////////////////////////////////////
  #define BUFFER_MAX 100
  byte modoNotificaciones=0;
  char Buffer[BUFFER_MAX]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
     
     //WHATSAPP
 byte indiceWhatsapp=0;
 byte modoWhatsapp=0;
 byte contWhatsapp=0;
     //GMAIL
 byte indiceGmail=0; 
 byte modoGmail=0;
  byte contGmail=0;
    //FACEBOOK
  byte indiceFacebook=0;
  byte modoFacebook=0;
   byte contFacebook=0;
     //LLAMADAS
  byte indiceNLlamada=0;
  byte modoNLlamada=0;
  byte contLlamadas=0;
      //SMS
  byte indiceSMS=0;
  byte modoSMS=0;
   byte contSMS=0;
     
  
  //////////////////////////////////////////
  /////// LLAMADAS ////////////////////////
  ////////////////////////////////////////
  #define BUFFER_NUMERO_MAX 9
  char BufferNumero[BUFFER_NUMERO_MAX]={0,0,0,0,0,0,0,0};
  int indiceLlamada=0;
  int modoLlamada=0;
  
  
  //----- Visualizacion en pantalla
  #define VISUALIZACION_MODO_COMIENZO 0
  #define VISUALIZACION_MODO_RELOJ 1
  #define VISUALIZACION_MODO_WHATSAPP 2
  #define VISUALIZACION_MODO_GMAIL 3
  #define VISUALIZACION_MODO_FACEBOOK 4
  #define VISUALIZACION_MODO_N_LLAMADA 5
  #define VISUALIZACION_MODO_SMS 6
  #define VISUALIZACION_MODO_LLAMADA 7
  #define VISUALIZACION_MODO_IDDLE 8
  #define VISUALIZACION_MODO_NOTIFICACIONES 9
  
  byte modoVisualizacion=VISUALIZACION_MODO_COMIENZO;
  
 byte centroX=64;
 byte centroY=32;
  
  ///////////////////////////////////////////////////////////////////
  //----- OLED 
  #define OLED_RESET 8
  Adafruit_SSD1306 display(OLED_RESET);
  
  #if (SSD1306_LCDHEIGHT != 64)
  #error("Height incorrect, please fix Adafruit_SSD1306.h!");
  #endif
  
  ///////////////////////////////////////////////////////////////////
  
  //-----  Control del Boton
  int pinBoton = 5;
  boolean estaPulsado = false;
  //
  
  void setup() {
    
    pinMode(pinBoton,INPUT);
    
    BTSerial.begin(9600);
    
    
    //----- by default, we'll generate the high voltage from the 3.3v line internally! (neat!)
    display.begin(SSD1306_SWITCHCAPVCC, 0x3c);  // initialize with the I2C addr 0x3D (for the 128x64)
    display.display();    // show splashscreen
    delay(1000);
    dibujarComienzo();    // 
    centroX = display.width() / 2;
    centroY = display.height() / 2;  
  
  }
  
  void loop() {
   boolean HaLLegadoInformacion = false;
    unsigned long tiempo_actual = 0;
    
    if (digitalRead(pinBoton)==LOW) {estaPulsado=LOW;}
  
    // Recibir datos por bluetooth y sacarlos del protocolo
    HaLLegadoInformacion= RecibirDatosBluetooth();
  
    // actualizar hora del reloj
    tiempo_actual= millis();
    
    actualizarHora(tiempo_actual);
    
    //Rutina de Visualizacion
    Dibujando(tiempo_actual);
    
    // Si no ha llegado la informacion esperar para guardar bateria
    if(!HaLLegadoInformacion)
      delay(300);
  }
  
  
  ///////////////////////////////////
  //----- Funciones Tiempo
  ///////////////////////////////////
  void ponerValorTiempo() {
    miMes = BufferTiempo[0];
    miDia = BufferTiempo[1];
    miSemana = BufferTiempo[2];    // 1: DOM, LUN, MAR, MIE, JUE, VIE,SAB
    miAmPm = BufferTiempo[3];    // 0:AM, 1:PM
    miHora = BufferTiempo[4];
    miMinutos =BufferTiempo[5];
  }
  
  
  /////////////////////////////////////////
  // Actualizar La Hora del Reloj         /
  /////////////////////////////////////////
  void actualizarHora(unsigned long tiempo_actual) {
    if(miMinutos >= 0) {
      if(tiempo_actual - tiempoAnteriorReloj > INTERVALO_TIEMPO_ACTUALIZACION) {
        // Incrementar tiempo
        miMinutos++;
        if(miMinutos >= 60) {
          miMinutos = 0;
          miHora++;
          if(miHora > 23) {
            miHora = 0;
            miSemana++;
            miDia++;
              if(miSemana > 7)
                  {
                    miSemana = 1;
                  }
                
             
              if(miDia > 30) 
                  { 
                   miDia = 1;// Yes. day is not exact.
                  } 
          }
        }
        tiempoAnteriorReloj = tiempo_actual;
      }
    }
    else {
      modoVisualizacion = VISUALIZACION_MODO_COMIENZO;
    }
  }
  
  ///////////////////////////////////
  //----- Funciones Bateria
  ///////////////////////////////////
  void ponerValorBateria(){
  miNivelBateria=BufferBateria[0];
  miEscalaBateria=BufferBateria[1];
  miEstadoCargaBateria=BufferBateria[2];
  miMetodoCargaBateria=BufferBateria[3];
  
  }
  
 
  ///////////////////////////////////
  //----- Funciones Notificaciones  /
  ///////////////////////////////////
  
  void iniciarBuffer(){
      for (int i=0;i<BUFFER_MAX;i++){
      Buffer[i]=0;
      }
  }
  //////////////////////////////////////////////////////
  //----- Protocolo Bluetooth, Procesar Datos Recibidos
  /////////////////////////////////////////////////////
  boolean RecibirDatosBluetooth() {
    int TransaccionFinalizada = false;
    while(!TransaccionFinalizada) {
      if(BTSerial.available()) {
        byte c = BTSerial.read();
       
        if(INDICE_TRANSACCION == TR_MODO_ESPERA) {
          procesarComienzoProtocolo(c);
        }
        else if(INDICE_TRANSACCION == TR_MODO_ESPERA_COMANDO) {
          procesarComando(c);
        }
        
        else if(INDICE_TRANSACCION == TR_MODO_ESPERA_TIEMPO) {
          procesarTiempo(c); 
        }
        else if(INDICE_TRANSACCION == TR_MODO_ESPERA_BATERIA) {
          procesarBateria(c);
          
        }
        
        else if(INDICE_TRANSACCION == TR_MODO_ESPERA_WHATSAPP) {
          procesarWhatsapp(c); 
        }
        
        else if(INDICE_TRANSACCION == TR_MODO_ESPERA_GMAIL) {
          procesarGmail(c); 
        }
        else if(INDICE_TRANSACCION == TR_MODO_ESPERA_FACEBOOK) {
          procesarFacebook(c); 
        }
        else if(INDICE_TRANSACCION == TR_MODO_ESPERA_N_LLAMADA) {
          procesarNLlamada(c); 
        }
        else if(INDICE_TRANSACCION == TR_MODO_ESPERA_SMS) {
          procesarSMS(c); 
        }
        
        else if(INDICE_TRANSACCION == TR_MODO_ESPERA_LLAMADA) {
          procesarLlamada(c);
        }
        
        else if(INDICE_TRANSACCION== TR_MODO_ESPERA_COMPLETADO) {
        }
        
      }  // Termina if(BTSerial.available())
      else {
       
        TransaccionFinalizada = true;
         return false;
      }
    }  // Termina while()
      return true;
  }  // Termina RecibirDatosBluetooth()
  
  void procesarComienzoProtocolo(byte c) {
  
    if(c == TRANSACCION_BYTE_COMIENZO) {
      INDICE_TRANSACCION = TR_MODO_ESPERA_COMANDO;
      COMANDO_TRANSACCION = NINGUN_COMANDO;
    }
  }
  
  void procesarComando(byte c) {
    
    if(c == COMANDO_PONER_TIEMPO) {
      INDICE_TRANSACCION = TR_MODO_ESPERA_TIEMPO;
      COMANDO_TRANSACCION = c;
    }
    
    else if(c == COMANDO_PONER_BATERIA) {
      INDICE_TRANSACCION = TR_MODO_ESPERA_BATERIA;   
      COMANDO_TRANSACCION = c;
    }
    
    else if(c == COMANDO_PONER_WHATSAPP) {
      INDICE_TRANSACCION = TR_MODO_ESPERA_WHATSAPP;   
      COMANDO_TRANSACCION = c;
    }
     else if(c == COMANDO_PONER_GMAIL) {
      INDICE_TRANSACCION = TR_MODO_ESPERA_GMAIL;   
      COMANDO_TRANSACCION = c;
    }
    else if(c == COMANDO_PONER_FACEBOOK) {
      INDICE_TRANSACCION = TR_MODO_ESPERA_FACEBOOK;   
      COMANDO_TRANSACCION = c;
    }
     else if(c == COMANDO_PONER_N_LLAMADA) {
      INDICE_TRANSACCION = TR_MODO_ESPERA_N_LLAMADA;   
      COMANDO_TRANSACCION = c;
    }
    else if(c == COMANDO_PONER_SMS) {
      INDICE_TRANSACCION = TR_MODO_ESPERA_SMS;   
      COMANDO_TRANSACCION = c;
    }
    
     else if(c == COMANDO_PONER_LLAMADA) {
      INDICE_TRANSACCION = TR_MODO_ESPERA_LLAMADA;   
      COMANDO_TRANSACCION = c;
    }
    
    else {
      INDICE_TRANSACCION = TR_MODO_ESPERA;
      COMANDO_TRANSACCION = NINGUN_COMANDO;
    }
  }
  
  
  void procesarTiempo(byte c) {
    if( COMANDO_TRANSACCION == COMANDO_PONER_TIEMPO) {
      if(indiceTiempo >= 0 && indiceTiempo < BUFFER_TIEMPO_MAX) {
        BufferTiempo[indiceTiempo] = (int)c;
        indiceTiempo++;
      }
      else {
       procesarTransaccion();
        INDICE_TRANSACCION = TR_MODO_ESPERA;
       
      }
    }
  }
  
  
  void procesarBateria(byte c) {
    if( COMANDO_TRANSACCION == COMANDO_PONER_BATERIA) {
      if(indiceBateria >= 0 && indiceBateria < BUFFER_BATERIA_MAX) {
        BufferBateria[indiceBateria] = (int)c;
        indiceBateria++;
      }
      else {
        procesarTransaccion();
        INDICE_TRANSACCION = TR_MODO_ESPERA;
      }
    }
  }
  
  void procesarWhatsapp(byte c){
    
    if (c==TRANSACCION_BYTE_FINAL){
    INDICE_TRANSACCION = TR_MODO_ESPERA;
    indiceWhatsapp=0;
    
    
    }  
    else if( COMANDO_TRANSACCION == COMANDO_PONER_WHATSAPP) {    
           Buffer[indiceWhatsapp]= (char)c;
           indiceWhatsapp++;
           modoWhatsapp=1;                               
    }
     
  }
  
   void procesarGmail(byte c){
    
    if (c==TRANSACCION_BYTE_FINAL){
    INDICE_TRANSACCION = TR_MODO_ESPERA;
    indiceGmail=0;
    }  
    else if( COMANDO_TRANSACCION == COMANDO_PONER_GMAIL) {    
           Buffer[indiceGmail]= (char)c;
           indiceGmail++;
         
            modoGmail=1;                               
    }
     
  }
  
   void procesarFacebook(byte c){
    
    if (c==TRANSACCION_BYTE_FINAL){
    INDICE_TRANSACCION = TR_MODO_ESPERA;
    indiceFacebook=0;
    }  
    else if( COMANDO_TRANSACCION == COMANDO_PONER_FACEBOOK) {    
           Buffer[indiceFacebook]= (char)c;
           indiceFacebook++;
         
           modoFacebook=1;                               
    }
     
  }
  
  void procesarNLlamada(byte c){
    
    if (c==TRANSACCION_BYTE_FINAL){
    INDICE_TRANSACCION = TR_MODO_ESPERA;
    indiceNLlamada=0;
    }  
    else if( COMANDO_TRANSACCION == COMANDO_PONER_N_LLAMADA) {    
           Buffer[indiceNLlamada]= (char)c;
           indiceNLlamada++;
         
           modoNLlamada=1;                               
    }
     
  }
 void procesarSMS(byte c){
    
    if (c==TRANSACCION_BYTE_FINAL){
    INDICE_TRANSACCION = TR_MODO_ESPERA;
    indiceSMS=0;
    }  
    else if( COMANDO_TRANSACCION == COMANDO_PONER_SMS) {   
         
           Buffer[indiceSMS]= (char)c;
           //Serial.print((char)c);
           indiceSMS++;
           modoSMS=1;   
                  
    }
     
  }
  void procesarLlamada(byte c){
    
    if (c==TRANSACCION_BYTE_FINAL){
    INDICE_TRANSACCION = TR_MODO_ESPERA;
    indiceLlamada=0;
    }  
    else if( COMANDO_TRANSACCION == COMANDO_PONER_LLAMADA) { 
             if(indiceLlamada >= 0 && indiceLlamada < 9) { 
      BufferNumero[indiceLlamada]=c;
      indiceLlamada++;
      modoLlamada=1;          
      }
    }
  }
  
 
 
  void procesarTransaccion() {
    
     if(COMANDO_TRANSACCION == COMANDO_PONER_TIEMPO) {
      ponerValorTiempo();
      indiceTiempo = 0;
      
     /* Serial.println (miMes);
      Serial.println (miDia);
      Serial.println (miSemana);
      //Serial.println (miAmPm);
      Serial.println (miHora);
      Serial.println (miMinutos);
     */
      
      }
    
    if(COMANDO_TRANSACCION == COMANDO_PONER_BATERIA) {
      ponerValorBateria();
      indiceBateria = 0;
      /*
      Serial.println (miNivelBateria);
      Serial.println (miEscalaBateria);
      Serial.println (miEstadoCargaBateria);
      Serial.println (miMetodoCargaBateria);
    */
     }
     
    if(COMANDO_TRANSACCION == COMANDO_PONER_WHATSAPP) {
     }
     
     if(COMANDO_TRANSACCION == COMANDO_PONER_LLAMADA) {
     }
  
  }
  
  //////////////////////////////////////////////////////
  //----- Metodos de dibujo en Pantalla
  /////////////////////////////////////////////////////
  
  // Rutina principal de dibujo en pantalla
  
  void Dibujando (unsigned long tiempoActual){
    
     
    if (modoVisualizacion==VISUALIZACION_MODO_COMIENZO){
    dibujarComienzo();
    }
  
    else if (modoVisualizacion==VISUALIZACION_MODO_RELOJ){
      
     if(estaPulsado==LOW){
  
       empezarModoNotificaciones();
     }
        
     else if (modoLlamada==1){
       empezarModoLlamada();
     }
     else if (modoWhatsapp==1){
       empezarModoWhatsapp();
     }
     else if (modoGmail==1){
       empezarModoGmail();
     }
     else if (modoFacebook==1){
       empezarModoFacebook();
     }
     else if (modoSMS==1){
       empezarModoSMS();
     }
        
     else{
          dibujarReloj();      
         }
    }
    
    else if (modoVisualizacion==VISUALIZACION_MODO_WHATSAPP){
          if (modoWhatsapp==1){
            dibujarWhatsapp();
          }
    
           else{
             empezarModoReloj();
           } 
     }
     else if (modoVisualizacion==VISUALIZACION_MODO_GMAIL){
          if (modoGmail==1){
            dibujarGmail();
          }
          else{
             empezarModoReloj();
          
           } 
     }
     else if (modoVisualizacion==VISUALIZACION_MODO_FACEBOOK){
          if (modoFacebook==1){
            dibujarFacebook();
          }
    
           else{
             empezarModoReloj();
           } 
     }
     
     else if (modoVisualizacion==VISUALIZACION_MODO_N_LLAMADA){
          if (modoNLlamada==1){
            dibujarNLlamada();
          }
          
          else{
             empezarModoReloj();
           } 
     }
     
     else if (modoVisualizacion==VISUALIZACION_MODO_SMS){
          if (modoSMS==1){
            dibujarSMS();
          }
          
           else{
             empezarModoReloj();
           } 
     }
     
     else if (modoVisualizacion==VISUALIZACION_MODO_LLAMADA){
         
          dibujarLLamada();    
           empezarModoReloj();     
     }
   
    
    else if (modoVisualizacion==VISUALIZACION_MODO_NOTIFICACIONES){
         
            
          dibujarNotificaciones();
          delay(5000);
          empezarModoReloj();    
     }
    
    else {
    empezarModoReloj();
    }
    
    estaPulsado=HIGH;
  } //Termina Dibujando()
  
  
  
  void empezarModoReloj(){
  modoVisualizacion=VISUALIZACION_MODO_RELOJ;
  }
   
  void empezarModoWhatsapp(){
  modoVisualizacion=VISUALIZACION_MODO_WHATSAPP;
  }
  
  void empezarModoGmail(){
  modoVisualizacion=VISUALIZACION_MODO_GMAIL;
  }
  
   void empezarModoFacebook(){
  modoVisualizacion=VISUALIZACION_MODO_FACEBOOK;
  }
  
   void empezarModoNLlamada(){
  modoVisualizacion=VISUALIZACION_MODO_N_LLAMADA;
  }
  void empezarModoSMS(){
  modoVisualizacion=VISUALIZACION_MODO_SMS;
  }
  void empezarModoLlamada(){
  modoVisualizacion=VISUALIZACION_MODO_LLAMADA;
  }
  
   void empezarModoNotificaciones(){
  modoVisualizacion=VISUALIZACION_MODO_NOTIFICACIONES;
 // Serial.println("visualizacionmodonotificaciones");
  }
  
  // Pantalla de comienzo
  
  void dibujarComienzo(){
    display.clearDisplay();
    
    display.drawBitmap(10, 15, IMG_logo_24x24, 24, 24, WHITE);
    
    display.setTextSize(2);
    display.setTextColor(WHITE);
    display.setCursor(45,12);
    display.println("Smart");
    display.setCursor(45,28);
    display.println("Watch");
    display.setTextSize(1);
    display.setCursor(45,45);
    display.setTextColor(WHITE);
    display.println("Arduino");
    display.display();
    delay(2000);
    
    empezarModoReloj();
  }
  
  // Dibuja la pantalla del reloj
  void dibujarReloj() {
    display.clearDisplay();
     
      display.setTextSize(2);
      display.setTextColor(WHITE);
      display.setCursor(centroX - 44, centroY - 28);
      display.print((const char*)pgm_read_word(&(StringSemana[miSemana])));
      display.print(",");
      display.setTextSize(2);
      display.setCursor(centroX + 11, centroY - 28);
      display.print(miDia);
      display.print("/");
      display.print(miMes+1);
  
      display.setTextSize(4);
      display.setCursor(centroX - 60, centroY-2);
      if(miHora < 10)
        display.print("0");
      display.print(miHora);
      display.print(":");
      if(miMinutos < 10)
        display.print("0");
      display.println(miMinutos);
      
      display.display(); 
  }
  
   void dibujarWhatsapp(){
     
     
     display.clearDisplay();
     //display.drawBitmap(centroX,centroY+8,whatsapp,24,24,BLACK);
     display.setTextSize(1);
     display.setTextColor(WHITE);
     display.setCursor(2,2);
     display.println(Buffer);
     display.display();
     delay(7000);
     contWhatsapp++;
     //Serial.println("ContadorWhatsapp");
     //Serial.println(contWhatsapp);
     if (contWhatsapp>=500){contWhatsapp=0;}
     modoWhatsapp=0;
     iniciarBuffer();
     empezarModoReloj();
     
   }   
  
   void dibujarGmail(){
     
     
     display.clearDisplay();
     display.drawBitmap(centroX,centroY+8,ICON_BITMAP_28,16,16,WHITE);
     display.setTextSize(1);
     display.setTextColor(WHITE);
     display.setCursor(2,2);
     display.println(Buffer);
     display.display();
     delay(5000);
     contGmail++;
     //Serial.println("ContadorGmail");
     //Serial.println(contGmail);
     if (contGmail>=10){contGmail=0;}
     modoGmail=0;
     iniciarBuffer();
     empezarModoReloj();
 
   }   
  void dibujarFacebook(){
     
     
     display.clearDisplay();
     
     display.drawBitmap(centroX,centroY+8,facebook_negro_24x24,24,24,BLACK);
     
     display.setTextSize(1);
     display.setTextColor(WHITE);
     display.setCursor(2,2);
     display.println(Buffer);
     display.display();
     delay(5000);
     contFacebook++;
     if (contFacebook>=15){contFacebook=0;}
     modoFacebook=0;
     iniciarBuffer();
     empezarModoReloj();
     
    
    
      
   }   
  void dibujarNLlamada(){
     
     
     display.clearDisplay();
     
     display.setTextSize(1);
     display.setTextColor(WHITE);
     display.setCursor(2,2);
     display.println(Buffer);
     display.display();
     delay(5000);
     contLlamadas++;
     if (contLlamadas>=3){contLlamadas=0;}
     modoNLlamada=0;
    
     empezarModoReloj();  
   }   
   
    void dibujarSMS(){
     
     
     display.clearDisplay();
     
    // display.drawBitmap(centroX,centroY+8,sms,16,16,WHITE);
     
     display.setTextSize(1);
     display.setTextColor(WHITE);
     display.setCursor(2,2);
     display.println(Buffer);
     display.display();
     delay(10000);
     contSMS++;
     if (contSMS>=5){contSMS=0;}
     modoSMS=0;
     
    
     empezarModoReloj();  
     iniciarBuffer();
   }   
  
   void dibujarLLamada(){
   
     display.clearDisplay();
     
     display.drawBitmap(centroX-60,centroY-20,ICON_BITMAP_11,16,16,WHITE);
     
     display.setTextSize(1);
     display.setTextColor(WHITE);
     display.setCursor(centroX-38,centroY-20);
     display.print("LLAMANDO...");
     display.setTextSize(2);
     display.setTextColor(WHITE);
     display.setCursor(centroX-58,centroY+10);
     display.println(BufferNumero);
     display.display();
     
     delay(10000);
     modoLlamada=0;
     indiceLlamada=0;
     contLlamadas++;
     if (contLlamadas>=5){contLlamadas=0;}
     modoNLlamada=0;
     empezarModoReloj(); 
   
   }
   
 
void dibujarNotificaciones(){
     
     display.clearDisplay();
     
     display.setTextSize(1);
     display.setTextColor(WHITE);
     display.setCursor(2,2);
     display.print(contWhatsapp);
     display.print(" Whatsapp");
     display.setTextSize(1);
     display.setTextColor(WHITE);
      display.setCursor(2,16);
     display.print(contFacebook);
     display.print(" Notificaciones");
     display.print(" Facebook");
     display.setTextSize(1);
     display.setTextColor(WHITE);
      display.setCursor(2,40);
     display.print(contGmail);
     display.print(" Emails");
     display.setTextSize(1);
     display.setTextColor(WHITE);
      display.setCursor(64,40);
     display.print(contSMS);
     display.print(" SMS");
     display.setTextSize(1);
     display.setTextColor(WHITE);
      display.setCursor(2,52);
     display.print(contLlamadas);
     display.print(" Llamadas");
     display.display();
     delay(5000);
     
     modoNotificaciones=0;
    
     empezarModoReloj();  
   }   
